Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -14,17 +19,25 @@
 #include <Descriptors/MoleculeDescriptor.hpp>
 #include <Descriptors/MoleculeIdDescriptor.hpp>
+#include <boost/lexical_cast.hpp>
 #include "TextUI/TextDialog.hpp"
 
 #include "World.hpp"
 #include "periodentafel.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
+
+#include <boost/lexical_cast.hpp>
 
 using namespace std;
+
+using boost::lexical_cast;
+using boost::bad_lexical_cast;
 
 
@@ -42,42 +55,66 @@
 }
 
-void TextDialog::queryBoolean(const char* title, bool* target, string description){
-  registerQuery(new BooleanTextQuery(title,target,description));
-}
-
-void TextDialog::queryInt(const char* title, int* target, string description){
-  registerQuery(new IntTextQuery(title,target,description));
-}
-
-void TextDialog::queryDouble(const char* title, double* target, string description){
-  registerQuery(new DoubleTextQuery(title,target,description));
-}
-
-void TextDialog::queryString(const char* title, string* target, string description){
-  registerQuery(new StringTextQuery(title,target,description));
-}
-
-void TextDialog::queryStrings(const char* title, vector<string>* target, string description){
-  registerQuery(new StringsTextQuery(title,target,description));
-}
-
-void TextDialog::queryAtom(const char* title, atom **target, string description) {
-  registerQuery(new AtomTextQuery(title,target,description));
-}
-
-void TextDialog::queryMolecule(const char* title, molecule **target, string description) {
-  registerQuery(new MoleculeTextQuery(title,target,description));
-}
-
-void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string description) {
-  registerQuery(new VectorTextQuery(title,target,cellSize,check,description));
-}
-
-void TextDialog::queryBox(const char* title,double ** const cellSize, string description) {
-  registerQuery(new BoxTextQuery(title,cellSize,description));
-}
-
-void TextDialog::queryElement(const char* title, std::vector<element *> *target, string description){
-  registerQuery(new ElementTextQuery(title,target,description));
+void TextDialog::queryBoolean(const char* title, string description){
+  registerQuery(new BooleanTextQuery(title,description));
+}
+
+void TextDialog::queryInt(const char* title, string description){
+  registerQuery(new IntTextQuery(title,description));
+}
+
+void TextDialog::queryInts(const char* title, string description){
+  registerQuery(new IntsTextQuery(title,description));
+}
+
+void TextDialog::queryDouble(const char* title, string description){
+  registerQuery(new DoubleTextQuery(title,description));
+}
+
+void TextDialog::queryDoubles(const char* title, string description){
+  registerQuery(new DoublesTextQuery(title,description));
+}
+
+void TextDialog::queryString(const char* title, string description){
+  registerQuery(new StringTextQuery(title,description));
+}
+
+void TextDialog::queryStrings(const char* title, string description){
+  registerQuery(new StringsTextQuery(title,description));
+}
+
+void TextDialog::queryAtom(const char* title, string description) {
+  registerQuery(new AtomTextQuery(title,description));
+}
+
+void TextDialog::queryAtoms(const char* title, string description) {
+  registerQuery(new AtomsTextQuery(title,description));
+}
+
+void TextDialog::queryMolecule(const char* title, string description) {
+  registerQuery(new MoleculeTextQuery(title,description));
+}
+
+void TextDialog::queryMolecules(const char* title, string description) {
+  registerQuery(new MoleculesTextQuery(title,description));
+}
+
+void TextDialog::queryVector(const char* title, bool check, string description) {
+  registerQuery(new VectorTextQuery(title,check,description));
+}
+
+void TextDialog::queryVectors(const char* title, bool check, string description) {
+  registerQuery(new VectorsTextQuery(title,check,description));
+}
+
+void TextDialog::queryBox(const char* title, string description) {
+  registerQuery(new BoxTextQuery(title,description));
+}
+
+void TextDialog::queryElement(const char* title, string description){
+  registerQuery(new ElementTextQuery(title,description));
+}
+
+void TextDialog::queryElements(const char* title, string description){
+  registerQuery(new ElementsTextQuery(title,description));
 }
 
@@ -95,6 +132,6 @@
 }
 
-TextDialog::IntTextQuery::IntTextQuery(string title, int * _target, std::string _description) :
-    Dialog::IntQuery(title,_target,_description)
+TextDialog::IntTextQuery::IntTextQuery(string title, std::string _description) :
+    Dialog::IntQuery(title,_description)
 {}
 
@@ -119,6 +156,35 @@
 }
 
-TextDialog::BooleanTextQuery::BooleanTextQuery(string title, bool * _target, std::string _description) :
-    Dialog::BooleanQuery(title,_target,_description)
+TextDialog::IntsTextQuery::IntsTextQuery(string title, std::string _description) :
+    Dialog::IntsQuery(title,_description)
+{}
+
+TextDialog::IntsTextQuery::~IntsTextQuery() {}
+
+bool TextDialog::IntsTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+  std::string line;
+  getline(cin,line);
+  // dissect by " "
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> temp;
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> temp;
+    tmp.push_back(temp);
+  }
+
+  return true;
+}
+
+TextDialog::BooleanTextQuery::BooleanTextQuery(string title, std::string _description) :
+    Dialog::BooleanQuery(title,_description)
 {}
 
@@ -148,6 +214,6 @@
 }
 
-TextDialog::StringTextQuery::StringTextQuery(string title,string *_target, std::string _description) :
-    Dialog::StringQuery(title,_target,_description)
+TextDialog::StringTextQuery::StringTextQuery(string title, std::string _description) :
+    Dialog::StringQuery(title,_description)
 {}
 
@@ -160,6 +226,6 @@
 }
 
-TextDialog::StringsTextQuery::StringsTextQuery(string title,vector<string> *_target, std::string _description) :
-    Dialog::StringsQuery(title,_target,_description)
+TextDialog::StringsTextQuery::StringsTextQuery(string title, std::string _description) :
+    Dialog::StringsQuery(title,_description)
 {}
 
@@ -169,5 +235,5 @@
   Log() << Verbose(0) << getTitle();
   getline(cin,temp);
-  // dissect by ","
+  // dissect by " "
   string::iterator olditer = temp.begin();
   for(string::iterator iter = temp.begin(); iter != temp.end(); ++iter) {
@@ -183,6 +249,6 @@
 }
 
-TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target, std::string _description) :
-    Dialog::DoubleQuery(title,_target,_description)
+TextDialog::DoubleTextQuery::DoubleTextQuery(string title, std::string _description) :
+    Dialog::DoubleQuery(title,_description)
 {}
 
@@ -206,6 +272,36 @@
 }
 
-TextDialog::AtomTextQuery::AtomTextQuery(string title, atom **_target, std::string _description) :
-    Dialog::AtomQuery(title,_target,_description)
+
+TextDialog::DoublesTextQuery::DoublesTextQuery(string title, std::string _description) :
+    Dialog::DoublesQuery(title,_description)
+{}
+
+TextDialog::DoublesTextQuery::~DoublesTextQuery() {}
+
+bool TextDialog::DoublesTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+  std::string line;
+  getline(cin,line);
+  // dissect by " "
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> temp;
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> temp;
+    tmp.push_back(temp);
+  }
+
+  return true;
+}
+
+TextDialog::AtomTextQuery::AtomTextQuery(string title, std::string _description) :
+    Dialog::AtomQuery(title,_description)
 {}
 
@@ -213,5 +309,5 @@
 
 bool TextDialog::AtomTextQuery::handle() {
-  int idxOfAtom=0;
+  int idxOfAtom=-1;
   bool badInput = false;
   do{
@@ -229,5 +325,5 @@
     tmp = World::getInstance().getAtom(AtomById(idxOfAtom));
     if(!tmp && idxOfAtom!=-1){
-      Log() << Verbose(0) << "Invalid Atom Index" << endl;
+      Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
       badInput = true;
     }
@@ -238,6 +334,46 @@
 }
 
-TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, std::string _description) :
-    Dialog::MoleculeQuery(title,_target,_description)
+
+TextDialog::AtomsTextQuery::AtomsTextQuery(string title, std::string _description) :
+    Dialog::AtomsQuery(title,_description)
+{}
+
+TextDialog::AtomsTextQuery::~AtomsTextQuery() {}
+
+bool TextDialog::AtomsTextQuery::handle() {
+  int idxOfAtom=-1;
+  Log() << Verbose(0) << getTitle();
+  std::string line;
+  getline(cin,line);
+  // dissect by " "
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> idxOfAtom;
+      temp = World::getInstance().getAtom(AtomById(idxOfAtom));
+      if(!temp && idxOfAtom!=-1){
+        Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
+        break;
+      }
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> idxOfAtom;
+    temp = World::getInstance().getAtom(AtomById(idxOfAtom));
+    if(!temp && idxOfAtom!=-1) {
+      Log() << Verbose(0) << "Invalid Atom Index" << idxOfAtom << endl;
+      tmp.push_back(temp);
+    }
+  }
+
+  return (idxOfAtom!=-1);
+}
+
+TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, std::string _description) :
+    Dialog::MoleculeQuery(title,_description)
 {}
 
@@ -270,6 +406,46 @@
 }
 
-TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check, std::string _description) :
-    Dialog::VectorQuery(title,_target,_cellSize,_check,_description)
+
+TextDialog::MoleculesTextQuery::MoleculesTextQuery(string title, std::string _description) :
+    Dialog::MoleculesQuery(title,_description)
+{}
+
+TextDialog::MoleculesTextQuery::~MoleculesTextQuery() {}
+
+bool TextDialog::MoleculesTextQuery::handle() {
+  int idxOfMol=-1;
+  Log() << Verbose(0) << getTitle();
+  std::string line;
+  getline(cin,line);
+  // dissect by " "
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> idxOfMol;
+      temp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
+      if(!temp && idxOfMol!=-1){
+        Log() << Verbose(0) << "Invalid Molecule Index" << idxOfMol << endl;
+        break;
+      }
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> idxOfMol;
+    temp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
+    if(!temp && idxOfMol!=-1){
+      Log() << Verbose(0) << "Invalid Molecule Index" << idxOfMol << endl;
+      tmp.push_back(temp);
+    }
+  }
+
+  return (idxOfMol!=-1);
+}
+
+TextDialog::VectorTextQuery::VectorTextQuery(std::string title, bool _check, std::string _description) :
+    Dialog::VectorQuery(title,_check,_description)
 {}
 
@@ -278,20 +454,86 @@
 
 bool TextDialog::VectorTextQuery::handle() {
-  Log() << Verbose(0) << getTitle();
-
-  char coords[3] = {'x','y','z'};
-  int j = -1;
-  for (int i=0;i<3;i++) {
-    j += i+1;
-    do {
-      Log() << Verbose(0) << coords[i] << "[0.." << cellSize[j] << "]: ";
-      cin >> (*tmp)[i];
-    } while ((((*tmp)[i] < 0) || ((*tmp)[i] >= cellSize[j])) && (check));
-  }
-  return true;
-}
-
-TextDialog::BoxTextQuery::BoxTextQuery(std::string title, double ** const _cellSize, std::string _description) :
-    Dialog::BoxQuery(title,_cellSize,_description)
+  std::cout << getTitle();
+  const Matrix &M = World::getInstance().getDomain().getM();
+  char coords[3] = {'x', 'y', 'z'};
+  for (int i=0;i<3;i++)
+    std::cout << coords[i] << "[0.." << M.at(i,i) << ( (i!=2) ? "], " : "]: ");
+
+  std::string line;
+  getline(cin,line);
+
+  // dissect by ","
+  double coord = 0.;
+  int counter = 0;
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); (iter != line.end()) && (counter != 3); ++iter) {
+    if (*iter == ',') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> coord;
+      tmp[counter++] = coord;
+      olditer = iter;
+    }
+  }
+  if ((olditer != line.begin()) && (counter != 3)) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> coord;
+    tmp[counter++] = coord;
+  }
+
+  // check vector
+  return World::getInstance().getDomain().isInside(tmp);
+}
+
+TextDialog::VectorsTextQuery::VectorsTextQuery(std::string title, bool _check, std::string _description) :
+    Dialog::VectorsQuery(title,_check,_description)
+{}
+
+TextDialog::VectorsTextQuery::~VectorsTextQuery()
+{}
+
+bool TextDialog::VectorsTextQuery::handle() {
+  std::cout << getTitle();
+  char coords[3] = {'x', 'y', 'z'};
+  const Matrix &M = World::getInstance().getDomain().getM();
+  for (int i=0;i<3;i++)
+    std::cout << coords[i] << "[0.." << M.at(i,i) << ( (i!=2) ? "], " : "]: ");
+
+  std::string line;
+  getline(cin,line);
+
+  // dissect by ","
+  double coord = 0.;
+  string::iterator olditerspace = line.begin();
+  string::iterator olditercomma = line.begin();
+  int counter = 0;
+  for(string::iterator vectoriter = line.begin(); vectoriter != line.end(); ++vectoriter) {
+    if (*vectoriter == ',')
+      counter++;
+    if ((*vectoriter == ' ') && (counter == 2)) {
+      counter = 0;
+      for(string::iterator componentiter = olditerspace; (componentiter != vectoriter) && (counter !=3); ++componentiter) {
+        if (*componentiter == ',') {
+          std::istringstream stream(string(componentiter, olditercomma));
+          stream >> coord;
+          temp[counter++] = coord;
+          olditercomma = componentiter;
+        }
+      }
+      if ((olditercomma != line.begin()) && (counter != 3)) { // insert last part also
+        std::istringstream stream(string(olditercomma, vectoriter));
+        stream >> coord;
+        temp[counter++] = coord;
+      }
+      if (World::getInstance().getDomain().isInside(temp))
+        tmp.push_back(temp);
+      olditerspace = vectoriter;
+    }
+  }
+
+  return true;
+}
+
+TextDialog::BoxTextQuery::BoxTextQuery(std::string title, std::string _description) :
+    Dialog::BoxQuery(title,_description)
 {}
 
@@ -302,14 +544,26 @@
   Log() << Verbose(0) << getTitle();
 
-  std::string coords[6] = {"xx","xy","xz", "yy", "yz", "zz"};
+  double temp[6];
+  std::string coords[6] = {"xx","yx","yy", "zx", "zy", "zz"};
   for (int i=0;i<6;i++) {
     Log() << Verbose(0) << coords[i] << ": ";
-    cin >> tmp[i];
-  }
-  return true;
-}
-
-TextDialog::ElementTextQuery::ElementTextQuery(std::string title, std::vector<element *> *_target, std::string _description) :
-    Dialog::ElementQuery(title,_target,_description)
+    cin >> temp[i];
+  }
+  Matrix M;
+  M.set(0,0, temp[0]);
+  M.set(0,1, temp[1]);
+  M.set(0,2, temp[2]);
+  M.set(1,0, temp[1]);
+  M.set(1,1, temp[3]);
+  M.set(1,2, temp[4]);
+  M.set(2,0, temp[2]);
+  M.set(2,1, temp[4]);
+  M.set(2,2, temp[5]);
+  tmp.setM(M);
+  return true;
+}
+
+TextDialog::ElementTextQuery::ElementTextQuery(std::string title, std::string _description) :
+    Dialog::ElementQuery(title,_description)
 {}
 
@@ -320,5 +574,5 @@
   bool badInput=false;
   bool aborted = false;
-  element * tmp = NULL;
+  const element * temp = NULL;
   do{
     badInput = false;
@@ -333,10 +587,8 @@
       }
       else{
-        tmp = World::getInstance().getPeriode()->FindElement(Z);
-        if(!tmp){
+        temp = World::getInstance().getPeriode()->FindElement(Z);
+        if(!temp){
           Log() << Verbose(0) << "No element with this atomic number!" << endl;
           badInput = true;
-        } else {
-          elements.push_back(tmp);
         }
       }
@@ -357,10 +609,8 @@
       }
       else{
-        tmp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
-        if(!tmp){
+        temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+        if(!temp){
           Log() << Verbose(0) << "No element with this shorthand!" << endl;
           badInput = true;
-        } else {
-          elements.push_back(tmp);
         }
       }
@@ -377,2 +627,53 @@
   return !aborted;
 }
+
+TextDialog::ElementsTextQuery::ElementsTextQuery(std::string title, std::string _description) :
+    Dialog::ElementsQuery(title,_description)
+{}
+
+TextDialog::ElementsTextQuery::~ElementsTextQuery()
+{}
+
+bool TextDialog::ElementsTextQuery::handle() {
+  std::string shorthand;
+  int Z=-1;
+  Log() << Verbose(0) << getTitle();
+  std::string line;
+  getline(cin,line);
+  // dissect by " "
+  string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> shorthand;
+      try {
+        Z = lexical_cast<int>(shorthand);
+        temp = World::getInstance().getPeriode()->FindElement(Z);
+      } catch (bad_lexical_cast) {
+        temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+      };
+      if(!temp && Z!=-1){
+        Log() << Verbose(0) << "Invalid Element" << shorthand << endl;
+        break;
+      }
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> shorthand;
+    try {
+      Z = lexical_cast<int>(shorthand);
+      temp = World::getInstance().getPeriode()->FindElement(Z);
+    } catch (bad_lexical_cast) {
+      temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+    };
+    if(!temp && Z!=-1) {
+      Log() << Verbose(0) << "Invalid Element" << shorthand << endl;
+      tmp.push_back(temp);
+    }
+  }
+
+  return (Z!=-1);
+}
Index: src/UIElements/TextUI/TextDialog.hpp
===================================================================
--- src/UIElements/TextUI/TextDialog.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextDialog.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -25,14 +25,20 @@
 
   virtual void queryEmpty(const char *, std::string = "");
-  virtual void queryBoolean(const char *, bool *, std::string = "");
-  virtual void queryInt(const char *, int *, std::string = "");
-  virtual void queryString(const char*, std::string *, std::string = "");
-  virtual void queryStrings(const char*, std::vector<std::string> *, std::string = "");
-  virtual void queryDouble(const char*, double*, std::string = "");
-  virtual void queryAtom(const char*,atom**,std::string = "");
-  virtual void queryMolecule(const char*,molecule**,std::string = "");
-  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
-  virtual void queryBox(const char*,double ** const, std::string = "");
-  virtual void queryElement(const char*, std::vector<element *> *, std::string = "");
+  virtual void queryBoolean(const char *, std::string = "");
+  virtual void queryInt(const char *, std::string = "");
+  virtual void queryInts(const char *, std::string = "");
+  virtual void queryString(const char*, std::string = "");
+  virtual void queryStrings(const char*, std::string = "");
+  virtual void queryDouble(const char*, std::string = "");
+  virtual void queryDoubles(const char*, std::string = "");
+  virtual void queryAtom(const char*,std::string = "");
+  virtual void queryAtoms(const char*,std::string = "");
+  virtual void queryMolecule(const char*,std::string = "");
+  virtual void queryMolecules(const char*,std::string = "");
+  virtual void queryVector(const char*,bool, std::string = "");
+  virtual void queryVectors(const char*,bool, std::string = "");
+  virtual void queryBox(const char*, std::string = "");
+  virtual void queryElement(const char*, std::string = "");
+  virtual void queryElements(const char*, std::string = "");
 
 protected:
@@ -47,5 +53,5 @@
   class BooleanTextQuery : public Dialog::BooleanQuery {
   public:
-    BooleanTextQuery(std::string title, bool *_target, std::string _description = NULL);
+    BooleanTextQuery(std::string title, std::string _description = NULL);
     virtual ~BooleanTextQuery();
     virtual bool handle();
@@ -54,6 +60,13 @@
   class IntTextQuery : public Dialog::IntQuery {
   public:
-    IntTextQuery(std::string title, int *_target, std::string _description = NULL);
+    IntTextQuery(std::string title, std::string _description = NULL);
     virtual ~IntTextQuery();
+    virtual bool handle();
+  };
+
+  class IntsTextQuery : public Dialog::IntsQuery {
+  public:
+    IntsTextQuery(std::string title, std::string _description = NULL);
+    virtual ~IntsTextQuery();
     virtual bool handle();
   };
@@ -61,6 +74,13 @@
   class DoubleTextQuery : public Dialog::DoubleQuery {
   public:
-    DoubleTextQuery(std::string title, double *_target, std::string _description = NULL);
+    DoubleTextQuery(std::string title, std::string _description = NULL);
     virtual ~DoubleTextQuery();
+    virtual bool handle();
+  };
+
+  class DoublesTextQuery : public Dialog::DoublesQuery {
+  public:
+    DoublesTextQuery(std::string title, std::string _description = NULL);
+    virtual ~DoublesTextQuery();
     virtual bool handle();
   };
@@ -68,5 +88,5 @@
   class StringTextQuery : public Dialog::StringQuery {
   public:
-    StringTextQuery(std::string title, std::string *_target, std::string _description = NULL);
+    StringTextQuery(std::string title, std::string _description = NULL);
     virtual ~StringTextQuery();
     virtual bool handle();
@@ -75,5 +95,5 @@
   class StringsTextQuery : public Dialog::StringsQuery {
   public:
-    StringsTextQuery(std::string title, std::vector<std::string> *_target, std::string _description = NULL);
+    StringsTextQuery(std::string title, std::string _description = NULL);
     virtual ~StringsTextQuery();
     virtual bool handle();
@@ -82,6 +102,13 @@
   class AtomTextQuery : public Dialog::AtomQuery {
   public:
-    AtomTextQuery(std::string title, atom **_target, std::string _description = NULL);
+    AtomTextQuery(std::string title, std::string _description = NULL);
     virtual ~AtomTextQuery();
+    virtual bool handle();
+  };
+
+  class AtomsTextQuery : public Dialog::AtomsQuery {
+  public:
+    AtomsTextQuery(std::string title, std::string _description = NULL);
+    virtual ~AtomsTextQuery();
     virtual bool handle();
   };
@@ -89,6 +116,13 @@
   class MoleculeTextQuery : public Dialog::MoleculeQuery {
   public:
-    MoleculeTextQuery(std::string title, molecule **_target, std::string _description = NULL);
+    MoleculeTextQuery(std::string title, std::string _description = NULL);
     virtual ~MoleculeTextQuery();
+    virtual bool handle();
+  };
+
+  class MoleculesTextQuery : public Dialog::MoleculesQuery {
+  public:
+    MoleculesTextQuery(std::string title, std::string _description = NULL);
+    virtual ~MoleculesTextQuery();
     virtual bool handle();
   };
@@ -96,6 +130,13 @@
   class VectorTextQuery : public Dialog::VectorQuery {
   public:
-    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = NULL);
+    VectorTextQuery(std::string title,bool _check, std::string _description = NULL);
     virtual ~VectorTextQuery();
+    virtual bool handle();
+  };
+
+  class VectorsTextQuery : public Dialog::VectorsQuery {
+  public:
+    VectorsTextQuery(std::string title,bool _check, std::string _description = NULL);
+    virtual ~VectorsTextQuery();
     virtual bool handle();
   };
@@ -103,5 +144,5 @@
   class BoxTextQuery : public Dialog::BoxQuery {
   public:
-    BoxTextQuery(std::string title,double ** const _cellSize, std::string _description = NULL);
+    BoxTextQuery(std::string title, std::string _description = NULL);
     virtual ~BoxTextQuery();
     virtual bool handle();
@@ -110,6 +151,13 @@
   class ElementTextQuery : public Dialog::ElementQuery {
   public:
-    ElementTextQuery(std::string title, std::vector<element *> *_target, std::string _description = NULL);
+    ElementTextQuery(std::string title, std::string _description = NULL);
     virtual ~ElementTextQuery();
+    virtual bool handle();
+  };
+
+  class ElementsTextQuery : public Dialog::ElementsQuery {
+  public:
+    ElementsTextQuery(std::string title, std::string _description = NULL);
+    virtual ~ElementsTextQuery();
     virtual bool handle();
   };
Index: src/UIElements/TextUI/TextStatusIndicator.cpp
===================================================================
--- src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/TextUI/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUI/TextUIFactory.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextUIFactory.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,11 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
 
 #include "UIElements/TextUI/TextUIFactory.hpp"
Index: src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- src/UIElements/TextUI/TextWindow.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextWindow.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -25,9 +30,8 @@
 #include "Views/StreamStringView.hpp"
 #include "Views/MethodStringView.hpp"
-#include "Helpers/MemDebug.hpp"
 
 #include "defs.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 // all needed due to config::SaveAll()
Index: src/UIElements/TextUI/TextWindow.hpp
===================================================================
--- src/UIElements/TextUI/TextWindow.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/TextUI/TextWindow.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,4 +11,5 @@
 #include "MainWindow.hpp"
 
+#include <string>
 #include <set>
 
Index: src/UIElements/UIFactory.cpp
===================================================================
--- src/UIElements/UIFactory.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/UIFactory.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/QT4/GLMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,5 +6,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "GLMoleculeView.hpp"
+
+#include "Helpers/MemDebug.hpp"
 
 GLMoleculeView::GLMoleculeView(QWidget *parent) :
Index: src/UIElements/Views/QT4/QTMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,9 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Views/QT4/QTMoleculeView.hpp"
 
 #include <iostream>
+
+#include "Helpers/MemDebug.hpp"
+
 #include "molecule.hpp"
-
 
 using namespace std;
Index: src/UIElements/Views/QT4/QTStatusBar.cpp
===================================================================
--- src/UIElements/Views/QT4/QTStatusBar.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Views/QT4/QTStatusBar.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include <sstream>
@@ -13,6 +18,9 @@
 
 #include "QTStatusBar.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
 #include "World.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "Actions/Process.hpp"
 
@@ -21,7 +29,7 @@
   QStatusBar(_parent),
   Observer("QTStatusBar"),
-  parent(_parent),
   atomCount(World::getInstance().numAtoms()),
-  moleculeCount(World::getInstance().numMolecules())
+  moleculeCount(World::getInstance().numMolecules()),
+  parent(_parent)
 {
   World::getInstance().signOn(this);
